﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace CustomSettingsPane
{
	public class MyGraphSource : SerializableGraphSourceBase<MyNode, MyLink>
	{
		public MyGraphSource()
		{
			var item1 = new MyNode() { CustomProp = "Item 1", Position = new Point(50, 50), IsSecondType = true };
			var item2 = new MyNode() { CustomProp = "Item 2", Position = new Point(250, 50), IsSecondType = false };

			this.AddNode(item1);
			this.AddNode(item2);
			this.AddLink(new MyLink() { Source = item1, Target = item2 });
		}

		public override string GetNodeUniqueId(MyNode node)
		{
			if (node != null)
				return node.CustomProp + " " + node.Position.ToString();
			else
				return null;
		}

		public override void SerializeNode(MyNode node, Telerik.Windows.Diagrams.Core.SerializationInfo info)
		{
			base.SerializeNode(node, info);
			info["CustopProp"] = node.CustomProp.ToString();
		}

		public override MyNode DeserializeNode(Telerik.Windows.Diagrams.Core.IShape shape, Telerik.Windows.Diagrams.Core.SerializationInfo info)
		{
			MyNode newNode = null;
			if (info["NodeUniqueIdKey"] != null)
				newNode = base.DeserializeNode(shape, info);
			else
				newNode = new MyNode() { CustomProp = "New Item" };

			if (info["CustopProp"] != null)
				newNode.CustomProp = info["CustopProp"].ToString();

			if (info["Position"] != null)
			{
				var position = Utils.ToPoint(info["Position"].ToString());
				if (position.HasValue)
				{
					newNode.Position = position.Value;
					info["Position"] = null;
				}
			}

			return newNode;
		}
	}
}
